import logging
import logging.config
import os
import time

logging.config.fileConfig(os.path.abspath(os.path.join("src/resources/config", 'logging.conf')))


class Logger(logging.LoggerAdapter):
    context = time.time().__str__().split('.')[0]

    def __init__(self, project='src'):
        super().__init__(logging.getLogger('logger'), {
            'context': self.context,
            'project': project
        })

    def process(self, msg: str, kwargs):
        prefix: dict = kwargs.pop('prefix', {})
        kwargs['extra'] = {
            'context': self.extra['context'],
            'project': self.extra['project'],
            'node_id': f":{prefix.pop('node_id')}" if prefix.get('node_id') else "",
            'step': f":step{kwargs.pop('step')}" if kwargs.get('step') else "",
            'node_name': prefix.get('node_name', 'NONE'),
            'node_desc': prefix.get('node_desc', 'NONE'),
            'result': kwargs.pop('result', '')
        }

        return msg, kwargs


class LoggerHelper:
    PASSED = "PASSED"
    FAILED = "FAILED"
