from src.core.logger import Logger
from src.core.logger.logger import LoggerHelper

from src.core.DI import container
from src.core.node import NodeServiceI


class NodeServiceWrapper:
    logger: Logger = container.logger()
    prefix: dict = {}

    def __init__(self, node: NodeServiceI):
        self.node = node
        self.prefix['node_id'] = self.node.id
        self.prefix['node_name'] = 'node_logic'
        self.prefix['node_desc'] = self.node.description

    def handle(self):
        try:
            self.logger.info('Запуск', prefix=self.prefix, result=LoggerHelper.PASSED)
            result: str = LoggerHelper.PASSED if self.node.handle() else LoggerHelper.FAILED
            self.logger.debug('Результат', prefix=self.prefix, result=result)
        except BaseException as exception:
            result: str = exception.__class__.__name__
            self.logger.warning(f'Результат: {exception}', prefix=self.prefix, result=LoggerHelper.FAILED)

        return result
